 '  program QuickBasic FOR QB64
 '  Resolution  on Rubik's Cube by Alain Renier year 2012.
    ' - Run under Windows XP. 
    '
    ' - You can save until 16 files, of data facettes
    '   enter one by one. 
    ' WARNING! 
    ' - The program must have a subdirectory  of Quickbasic named "RUBIKUK".
    ' - In this subdirectory must be set the files:
    ' - CUBDATA.RBK, TRANSIND.RBK and CUB641AE.BAS
    ' - IF the  files doesn't in the subdirectory, the program don't run
    '   {STOP WITH WARNING ERROR!.}
    '    Also the files  "RUBIK1.RBK to "RUBIKX.RBK"  (X= order number)
    '   if this already existes. They are files of data saved having
    '    the name  "RUBIK1.RBK  to  RUBIK16.RBK"
    ' - IF they files doesn't in the subdirectory, the program don't get
    '    a data recovery possible.
    '   If QB64 is intalled on an another disk    
    ' - Please, Modify the line [ab$ = "D:\qb64\rubikuk"]
    ' - Some details on  the arrays of  variables used:
    ' - cf%(i%,j%)    Array mirror,  container of color facets
    ' - tf%(k%)        number of cube who must have a position k
    ' - Current configuration
    ' - C%(i%,j%)     Color of facet i%,j%; and weight binary of cube elementary
    ' - t%(K%)        number of cube occupying the position k
    ' - z%(K%)        position occupy by the cube k
    ' - co%(6)        Contain the color by default
    ' - vo%(6)        Suite of weight binary of values 1, 2, 4, 8, 16 ou 32.
    ' - Colors of the cube by default
    ' - white = 1,    green  = 2,    Red    =    3,
    ' - Blue  = 4,    Orange = 5,    yellow =    6 
    ' - P% array of 9 positions, but 6 only are used for the cube
    ' - Colors realles
    ' - P%(1 ) TO (6)     Contain the color realle for the screen (SCREEN 12 MS-DOS) in order :
    ' - white = 15,   green  = 2,    Red    = 4,
    ' - Blue  = 9,    Orange = 12,   yellow = 14
    ' - P%(7) TO (9) for use in the program
    ' - Cyan = 11,    Grey = 8,      greenlight = 10
    ' - ss%(20) sum of weight 2^x-1  of summit and ridges
    ' - Init:
    ' - array container of movements (contain in CUBDATA.RBK)
    '     Bf1$(112)    -->    data    "Rf1$" :     Printing
    '     Bc1$(112)    -->    data    "Cm1$" :     execute
    '     Bf2$(99)     -->    data    "Rf2$" :    Printing
    '     Bc2$(99)     -->    data    "Cm2$" :    execute
    '     Bf3$(27)     -->    data    "Rf3$" :    Printing
    '     Bc3$(27)     -->    data    "Cm3$" :    execute
    ' - array of index:   (contain in TRASIND.RBK)
    '    id1% integer    -->    pointer on data of Bf1$ and Bc1$
    '    id2% integer    -->    pointer on data of Bf2$ and Bc2$
    '    id3% integer    -->    pointer on data of Bf3$ and Bc3$
    '    so%(54) integer -->    used to calculate the coefficient K% in calcv
    '************************************************************************************************  
5
 ' Arrays  commons used in the program
    COMMON SHARED C%(), cf%(), tf%(), t%(), z%(), w%(), vo%(), L%, K%, gm$, tem%, tconf%
    COMMON SHARED delier#, drl#, cdir$(), B%
    ' Array calls parameters of subroutines    test, testt1    
    TYPE bap
        tst1 AS INTEGER
        tst2 AS INTEGER
    END TYPE
    ' Array calls parameters of subroutines  testk1, testk2
    TYPE sap
        tsk1 AS INTEGER
        tsk2 AS INTEGER
        tsk3 AS INTEGER
        tsk4 AS INTEGER
    END TYPE
    ' Colors screen
    TYPE nocol
        kol AS STRING * 6
    END TYPE
    ' Message to send
    TYPE R
        Ms AS STRING * 8
    END TYPE
    ' declare shared arrays
    DIM SHARED C%(6, 9), cf%(6, 9), tf%(20), t%(20), z%(20)
    DIM SHARED s%(20), ss%(20), w%(32), co%(6), vo%(6)
    DIM SHARED tr$(4)
    DIM SHARED Bf1$(112), Bc1$(112), Bf2$(99), Bc2$(99), Bf3$(27), Bc3$(27)
    DIM SHARED id1%(18), id2%(18), id3%(6), so%(54), P%(10)
    ' shared Variables
    DIM SHARED pmsa$, cdir$(16), bd%, V%, con$, kx1%, ky1%, kx2%, ky2%
    DIM SHARED rf1$, rf2$, rf3$, cm1$, cm2$, cm3$, scrn%, ea%, kfc
    DIM SHARED kfsn%, stat%, xtdir%, xtfich%, lign%, col%, cz%, la%, lb%
    DIM SHARED afli%, afcol%, spr%, facpp%
    DIM SHARED COIhdG$, COIhdD$, DCOte$, HOriD$, COIbdG$, COIbdD$
    DIM SHARED aptst(1 TO 78) AS bap
    DIM SHARED aptsk(1 TO 35) AS sap
    DIM SHARED nocou(8) AS nocol
    CONST angl    = 30, pi#    = 3.14159265357989#
    CONST TRUE    = -1, FALSE = 0
    CONST bt%    = 1, bu%    = 2, bv% = 3, bw% = 4
    CONST nbfac%    = 6, nfacet%    = 9
    HOriD$  = CHR$(205)  ' 0CDh
    COIhdD$ = CHR$(187)  ' 0BBh
    COIhdG$ = CHR$(201)  ' 0C9h
    COIbdD$ = CHR$(188)  ' 0BCh
    COIbdG$ = CHR$(200)  ' 0C8h
    DCOte$  = CHR$(186)  ' 0BAh
    ' array pointer for move in index array 
    DIM SHARED bl%(18)
    bl%(1)  = 0: bl%(2)  = 12: bl%(3)  = 11: bl%(4)  = 10
    bl%(5)  = 0: bl%(6)  = 8:  bl%(7)  = 7:  bl%(8)  = 7
    bl%(9)  = 9: bl%(10) = 8:  bl%(11) = 7:  bl%(12) = 6
    bl%(13) = 5: bl%(14) = 4:  bl%(15) = 3:  bl%(16) = 5
    bl%(17) = 4: bl%(18) = 3
    ' colors by default
    white%  = 15: green%   = 2:  red%    = 4
    Blue%   = 9:  Orange%  = 12: yellow% = 14
    Grey%   = 8:  greenlg% = 10: Cyan%   = 11
    redLig% = 13
    ' array P% obtain elements of color
    P%(1)    = white%    '(face 1)
    P%(2)    = green%    '(face 2)
    P%(3)    = red%      '(face 3)
    P%(4)    = Blue%     '(face 4)
    P%(5)    = Orange%   '(face 5)
    P%(6)    = yellow%   '(face 6)
    P%(7)    = Cyan%     '(printing)
    P%(8)    = grey%     '(neutre)
    P%(9)    = greenlg%  '(printing)
    P%(10)    = redLig%
    nocou(1).kol = "WHITE "
    nocou(2).kol = "GREEN "
    nocou(3).kol = "RED   "
    nocou(4).kol = "BLUE  "
    nocou(5).kol = "ORANGE"
    nocou(6).kol = "YELLOW"
    con$ = " < Press a key to continue >"
    afli% = 9: Afcol% = 42
    de% = FALSE
    ' In case possible of an error
    ON ERROR GOTO traiterreur
    _TITLE "*** CHOICE YOUR SCREEN MODE. ***"
    LOCATE 10, 2
    COLOR p%(7)
    PRINT " Choice of screen mode "
    PRINT "      1 = 640 x 480 mode 12 "
    PRINT "      2 = 800 x 600 256   "
    LOCATE CSRLIN, 2
    DO
        INPUT " <1> or <2> "; scrn%
    LOOP UNTIL scrn% = 1 OR scrn% = 2
    IF scrn% = 1 THEN
        a& = _NEWIMAGE(640, 480, 12)
        SCREEN a&
        _SOURCE a&
        _DEST a&
        WIDTH 80, 60
        Kx1% = 186: Ky1% = 150
        Kx2% = 480: Ky2% = Ky1%     '
        la% = 48: cz% = 79
        lb% = 51: kfc = 1: spr% = 2
    ELSE
        b& = _NEWIMAGE(800, 600, 256)
        SCREEN b&
        _SOURCE b&
        _DEST b&
        TTFont$ = "LUCON":height& = 12:style$ = "Monospace, BOLD"
        fnt& = _LOADFONT("C:\Windows\Fonts\" + TTFont$ + ".ttf", height&, style$)
        _FONT fnt&, b& 
        Kx1% = 206: Ky1% = 194
        Kx2% = 540: Ky2% = Ky1%
        la% = 38: cz% = 88
        lb% = 41: kfc = 800/640: spr% = 3
    END IF
    _TITLE "*** RUBIK'S CUBE FOR QB64. ***"
    _SCREENHIDE          ' Hide the movements of screen
    _SCREENMOVE _MIDDLE  ' center screen
    _SCREENSHOW
    ab$ = "D:\qb64\rubikuk"
    IF _DIREXISTS(ab$) THEN
        CHDIR ab$
        xtdir% = TRUE
    ELSE
        ERROR 76
    END IF
    facpp% = FALSE
    ' delta time = .1 s
    drl# = .1
    ' coefficient sinus x ( on degr)
    Kfsn% = (CINT(angl * (SIN(angl * (pi# / 180)))))  '  sin30 = 1/2 --> Kfsn% = 15
    ab$ = "cubdatae.rbk"
    IF _FILEEXISTS(ab$) THEN
        fich% = FREEFILE
        OPEN ab$ FOR INPUT AS #fich%
        'Init the array  of data Bf1$ and Bc1$
        Tablo 224, fich%, Bf1$(), Bc1$()
        'Init the array  of data Bf2$ and Bc2$
        Tablo 198, fich%, Bf2$(), Bc2$()
        'Init the array  of data Bf3$ and Bc3$
        Tablo 54, fich%, Bf3$(), Bc3$()
        CLOSE #fich%
    ELSE
        ERROR 53
    END IF
    ab$ = "transind.rbk"
    IF _FILEEXISTS(ab$) THEN
        fich% = FREEFILE
        OPEN ab$ FOR BINARY AS #fich%
        'Init the array of index
        Tablau 36, fich%, id1%(), id2%()
        Tablax 6, fich%, id3%()
        'Init the array of jumps
        Tablax 54, fich%, so%()
        'Init the array of call  Test and TestT1
        Tablat 78, fich%, Aptst(), Aptsk(), 1
        'Init the array of call  TestK1 and TestK2
        Tablat 35, fich%, Aptst(), Aptsk(), 2
        ' Init array of ensembles summits (8) and ridges(12)
        Tablax 20, fich%, ss%()
        CLOSE #fich%
    ELSE
        ERROR 53
    END IF
    FOR i% = 1 TO nbfac%
        ' color virtuale of faces
        co%(i%) = i%
        ' value (weight of facets) vo%(x) = 1, 2, 4, 8, 16 or 32
        vo%(i%) = 2 ^ (i% - 1)
        ' w%(x) contain the color checking by the value of weight  of the  facette.
        w%(vo%(i%)) = i%
    NEXT i%
    ' at the start, the array of files is empty. 
    FOR i% = 1 TO UBOUND(cdir$)
        cdir$(i%) = ""
    NEXT i%
    ' Init general.
    FaiLinit 2
    tconf% = 0
'    xtdir% = FALSE
    xtfich% = FALSE
    ' for obtain only the directorys.
    attr1$ = "/A:D/B"
    ' <dir.rep> for contain the directorys.
    attr2$ = "dir.rep"
    ' name of  directory and/or the files by default
    attr3$ = "rubik"
    Collect attr1$, attr2$, attr3$, cdir$()
    ' for obtain only the names of files with  extend ".rbk" by default
    attr1$ = "*.rbk /B"
    ' to make in file  <dir.txt>
    attr2$ = "dir.txt"
    ' rubik = name  automatically  by default, attr3$ = "rubik"
    Collect attr1$, attr2$, attr3$, cdir$()
    IF xtfich% THEN ' = TRUE 
        ' find the upper limit on the number of files
        FOR i% = 1 TO UBOUND(cdir$)
            IF cdir$(i%) <> "" THEN
                mind% = i%
            ELSEIF cdir$(i%) = "" THEN
                EXIT FOR
            END IF
        NEXT i%
        Tri cdir$()
    END IF
    full = _FULLSCREEN
    IF full = 0 THEN
        _FULLSCREEN
    END IF
    DO
        q$ = " FINAL "
        hf% = Mconfig%(q$)
        ' Wait  HF = 1  Cube normal, or HF = 2  Rotate the faces
        ' Cas 1, cube normal
        FaiLinit 1
        FaiLinit 2
        efface 0, 0, 0
        q$ = " INITIAL "
        hi% = Mconfig%(q$)
        IF (hf% = 1) AND (hi% = 1) THEN
            LOCATE 6, 2
            PRINT " *** You can't have an initial configuration = Cube normal***"
            LOCATE 7, 14: PRINT " *** and a final configuration = Cube Normal !  ***"
            LOCATE 8, 14: PRINT " ***** In this case, the software does nothing  !  ****"
            LOCATE 9, 14
            PRINT " *********   Repeat your selection S.V.P. ********* "
            Delier# = 4:Delay
            ' delete the message on screen
            efface 0, 0, 0
        ELSEIF    (hf% = 2 AND hi% = 2) OR (hf% = 1 AND hi% = 2)_
            OR    (hf% = 1 AND hi% = 3) OR (hf% = 2 AND hi% = 3) THEN
            EXIT DO
        END IF
    LOOP
    ' Rotate the faces
    IF (hi% = 2) AND (hf% = 1) THEN
        movself 1
        Affect
        tconf% = 1
    ELSEIF (hi% = 2) AND (hf% = 2) THEN
        movself 0
        LOCATE la%, 2: PRINT " Do you want another exercice <Y>es     <N>o";
        DO UNTIL nc$ = "Y" OR nc$ = "N"
            nc$ = UCASE$(INKEY$)
        LOOP
        IF nc$ = "Y" THEN
            CLS
            LOCATE 10, 10: PRINT " Wait a moment please. "
            full = _FULLSCREEN
            IF full > 0 THEN
                _FULLSCREEN _OFF
            END IF
            SLEEP 2
            SCREEN 0
            CLEAR
            RUN 5
        END IF
        SYSTEM
    ELSEIF (hi% = 3) AND (hf% = 2) THEN
        ' nothing to make...
    END IF
    IF hi% = 3 THEN
        AffCadr 12
        ' If files already existe
        IF xtfich% THEN
            COLOR P%(7): LOCATE 4, 2
            FOR i% = 1 to 6
                PRINT STRING$(50, " ")
                LOCATE CSRLIN, 2
            NEXT i%
            LOCATE 4, 4: PRINT " Retrieve data ?  <Y / N> ";
            LOCATE la%, 4: PRINT " To enter COLORs of the facets, to answer NOT "
            PRINT con$
            SLEEP
            effa52
            PRINT STRING$(cz% - 1, " ")
            LOCATE 4, 36: psa$ = req$(psa$, "Y", "N")
        END IF
        IF hf% = 1 THEN
            LOCATE 6, 4: PRINT " operation step by step ? <Y / N> ";
            loq% = CSRLIN: posa% = POS(0) 
            LOCATE la%, 2: PRINT " Use the mode Step by step if you have a RUBIK'S CUBIC "
            LOCATE CSRLIN, 2: PRINT "  and if you wish to solve it. "
            PRINT con$
            SLEEP
            efface 1, la%, la% + 2
            LOCATE loq%, posa%
            pmsa$ = req$(pmsa$, "Y", "N")
        END IF
        LOCATE 4, 4: PRINT STRING$(40, " ")
        LOCATE 6, 4: PRINT STRING$(40, " ")
        IF (psa$ = "Y") AND (xtfich%) THEN
            ' PRINT the files
            IF mind% <> 0 THEN Affichier mind%, cdir$()
            LOCATE Csrlin + 2, 4: PRINT "What file ? 1 to ";mind%;"  ";
            COLOR P%(1)
            i% = 0
            DO UNTIL (i% > 0) AND (i% <= mind%) 
                INPUT ;"",i%
            LOOP
            LOCATE la%, 2
            PRINT con$
            SLEEP
            effa52
            COLOR P%(7)
            nomfic$ = cdir$(i%)
            nfich% = FREEFILE
            OPEN nomfic$ FOR BINARY AS nfich%
            LirEcrir nfich%, C%(), 1
            CLOSE #nfich%
            IF pmsa$ = "Y" THEN
                regles
            END IF
            COLOR P%(1)
            Affect
            tconf% = 2
        ELSE
            CLS
            dkolfac
            tconf% = 1
            facpp% = TRUE
        END IF
    END IF
    IF (tconf% = 1 AND facpp%) OR (tconf% = 1 AND stats% > 0) THEN
    '    CLS
        efface 1, 1, 14
        AffCadr 10 
        LOCATE 4, 4: PRINT " Save the data <Y / N> ";
        sa$ = Req$(sa$, "Y", "N")
        IF sa$ = "Y" THEN
            nfich% = FREEFILE
            LOCATE 5, 4
            IF xtfich% = FALSE THEN
                cfichier mind%, mname$
                OPEN mname$ FOR BINARY AS nfich%
            ELSEIF mind% < UBOUND(cdir$) THEN
                cfichier mind%, mname$
                OPEN mname$ FOR BINARY AS nfich%
            ELSEIF mind% = UBOUND(cdir$) THEN
                PRINT "The maximum file already exists! "
                LOCATE CSRLIN, 4: PRINT "replace on ? <Y> ou <N>"
                sa1$ = Req$(sa1$, "Y", "N") '
                LOCATE 5, 4 : PRINT STRING$(50," ")
                LOCATE 6, 4 : PRINT STRING$(50," ")
                'CLS
                IF sa1$ = "N" THEN
                    LOCATE 5, 4: PRINT " File not saved";
                    PRINT " limit is reached. (limit = ";UBOUND(cdir$)
                ELSE
                    Affichier mind%, cdir$()
                    PRINT " Which file ? " ;
                    rng% = VAL(INPUT$(2))
                    mname$ = cdir$(rng%)
                    OPEN mname$ FOR BINARY AS nfich%
                END IF
            END IF
            LirEcrir nfich%, C%(), 2
            CLOSE #nfich%
            LOCATE CSRLIN, 4: PRINT " File ";mname$, " recorded" 
        ELSE
            ta% = 11
            LOCATE 3, 1: PRINT COIbdG$ + STRING$(cz% - 2, HOriD$) + COIbdD$
            efface 1, 4, ta%
        END IF
        IF facpp% THEN facpp% = FALSE
    END IF
    IF hi% = 3 AND hf% = 2 THEN
        movself 0
        LOCATE la%, 2: PRINT " Do you want another exercise?   <Y>es     <N>o";
        DO UNTIL nc$ = "Y" OR nc$ = "N"
            nc$ = UCASE$(INKEY$)
        LOOP
        IF nc$ = "O" THEN
            CLS
            LOCATE 10, 10: PRINT " Wait one moment please. "
            full = _FULLSCREEN
            IF full > 0 THEN
                _FULLSCREEN _OFF
            END IF
            SLEEP 2
            SCREEN 0
            CLEAR
            RUN 5
        END IF
        SYSTEM
    END IF    
    '******** RECONSTITUTION OF THE CUBE ********
    COLOR P%(1)
    LOCATE la%, 2
    PRINT con$
    SLEEP
    effa52
    efface 1, 1, 14
    Affcadr 2
    ba$ = "Reconstruct the cube"
    COLOR P%(1)
    LOCATE 4, ((cz% - 1) - INT(LEN(ba$) + 2)) / 2: PRINT STRING$(24, "*")
    LOCATE CSRLIN, (cz% - INT(LEN(ba$))) / 2: PRINT ba$
    LOCATE CSRLIN, ((cz% - 1) - INT(LEN(ba$) + 2)) / 2: PRINT STRING$(24, "*")
    ' identificator of  progress in the loop main.
    B% = 0
    ' variable of jump "So%()"
    dx% = 1
    DO    ' Loop main
        IF pmsa$ = "N" THEN
            COLOR P%(9)
            LOCATE la%, 2: PRINT "To stop temporarly, press T ";
            PRINT " then press <enter> to resume ";
            COLOR P%(1)
        END IF
        LOCATE la% + 1, 2: PRINT "If  sign + =  clockwise "
        LOCATE CSRLIN, 2: PRINT "If  sign - =  counter-clockwise "
        ' calculate  B%, K%, V%
        CalcV B%, K%, V%, so%(dx%), so%(dx% + 1), so%(dx% + 2)
        ' Printing on the screen
        Posit B%, K%, V%
        ' progress  index for 3 steps
        dx% = dx% + 3
        Ta$ = UCASE$(INKEY$)
        IF Ta$ = "Q" THEN
            lign% = Csrlin :col% = POS(0)
            LOCATE la%, 5: PRINT "Do you want to quit ?  press  <Q> or <N> to continue"
            Delier# = 4:Delay
            effa52
            LOCATE la%, 5: PRINT "Please confirm  <Q>uit or <N>o "
            Ta$ = Req$(Ta$, "Q", "N")
            effa52
            IF Ta$ = "Q" THEN
                EXIT DO
            ELSE
                effa52
                LOCATE lign%, Col%
            END IF
        END IF
        SELECT CASE B%
            ' cas 1 to 4 , and 9 to 14   call at " Test"  and  "TestT1"
            CASE 1 TO 4, 9 TO 14
                ' 2 parameters are  needed
                Atrib 0, 13, 1, 13, 1, 0, q0%, q1%, 0, 0, 0
                ' cas K% = 1
                IF K% = 1 THEN
                    Test q0%, q1%, V%, Rf1$, Cm1$
                ' cas K% of 2 to 12
                ELSEIF (K% > 1) AND (K% < 13) THEN
                    TestT1 q0%, q1%, V%, Rf1$, Rf2$, Cm1$, Cm2$
                END IF
            '  cas 5 to 8 , and 16, 17  make call to "TestK1" and "TestK2"
            CASE 5 TO 8, 16, 17
                ' 4 parameters are needed
                Atrib 0, 9, 0, 9, 0, 0, q0%, q1%, q2%, q3%, 1
                IF B% < 9 THEN mg% = id3%(B% - 4) + K% - 1
                IF B% = 16 OR B% = 17 THEN mg% = id3%(B% - 11) + K% - 1
                Rf3$ = Bf3$(mg%)
                Cm3$ = Bc3$(mg%)
                ' cas K% = 1
                IF K% = 1 THEN
                    TestK1 q0%, q1%, q2%, q3%, V%, Rf1$, Rf2$, Cm1$, Cm2$
                ' cas K% of 2 to 8
                ELSEIF (K% > 1) AND (K% < 9) THEN
                    TestK2 q0%, q1%, q2%, q3%, V%, Rf1$, Rf2$, Rf3$, Cm1$, Cm2$, Cm3$
                END IF
            ' cas 15 is special. make 2 times a call  to "Test" if K% = 2
            CASE 15
                ' cas K% = 1 and K% = 2
                Atrib 0, 3, 0, 0, 0, 0, q0%, q1%, 0, 0, 0
                    Test q0%, q1%, V%, Rf1$, Cm1$
                ' cas K% = 2
                IF K% = 2 THEN
                    LOCATE Afli%, Afcol%
                    Atrib 0, 3, 0, 0, 0, 1, q0%, q1%, 0, 0, 0
                    Test q0%, q1%, V%, Rf1$, Cm1$
                END IF
            CASE 18
                ' cas K% = 1
                Atrib 0, 2, 0, 2, 0, 0, q0%, q1%, q2%, q3%, 1
                IF K% = 1 THEN
                    TestK1 q0%, q1%, q2%, q3%, V%, Rf1$, Rf2$, Cm1$, Cm2$
                ELSE
                    ' if B% = 18 and K% = 2, cannot resolve
                    IF de% = FALSE THEN
                        effa52
                        LOCATE la% + 1, 1: PRINT STRING$(40, " ")
                        LOCATE la% + 2, 1: PRINT STRING$(40, " ");
                        LOCATE la% , 2: PRINT "POSITION not resolved.  Second try... "
                        de% = TRUE
                        PRINT con$
                        SLEEP
                        affect
                        B% = 0
                        dx% = 1
                    ELSE
                        LOCATE la% + 2: PRINT "POSITION NOT POSSIBLE."
                    END IF
                END IF
        END SELECT
        ' If B% = 18  it's end !
    LOOP UNTIL B% = 18
    IF pmsa$ = "N" THEN
        LOCATE 5, 50: PRINT STRING$(30, " ")
        LOCATE 6, 50: PRINT STRING$(30, " ")
        effa52
        PRINT STRING$(50, " ");
    END IF
    LOCATE la% + 1, 1: PRINT STRING$(40, " ")
    LOCATE la% + 2, 1: PRINT STRING$(40, " ")
    LOCATE la%, 2: PRINT " "; stat%; " movements carried out! ";"  < any key to end >"
    SLEEP
    effa52
    PRINT "Do you want another exercice?   <Y>es     <N>o";
    DO UNTIL nc$ = "Y" OR nc$ = "N"
        nc$ = UCASE$(INKEY$)
    LOOP
    IF nc$ = "Y" THEN
        CLS
        LOCATE 10, 10: PRINT " Wait a moment please. "
        full = _FULLSCREEN
        IF full > 0 THEN
            _FULLSCREEN _OFF
        END IF
        SLEEP 2
        SCREEN 0
        CLEAR
        RUN 5
    END IF
    SYSTEM
traiterreur:
    lg% = CSRLIN:pg% = POS(0)
    SELECT CASE ERR
        CASE 5
            LOCATE la%, 2
            PRINT "** Function call prohibited - ERROR "+ Str$(ERR)
            PRINT " Error at line " + Str$(_ERRORLINE)
            PRINT con$
            SLEEP
            aaerre% = aaerre% + 1
            aerr aaerre%
            CASE 6
            LOCATE lb%, 2
            PRINT "** Overflow - ERROR " + Str$(ERR)
            PRINT " Error at line " + Str$(_ERRORLINE)
            PRINT con$
            SLEEP
            Berre% = Berre% + 1
            aerr bberre%
        CASE 7
            CLS
            LOCATE lb%, 2
            PRINT "** Insufficient memory - ERROR " + Str$(ERR)
            PRINT "   termination of the program  Correct the defect if possible "
            PRINT "   and restart the program !  "
            PRINT "<press a key to end..>"
            SLEEP
            SYSTEM
        CASE 9
            LOCATE lb%, 2
            PRINT "** Index out of bounds - ERROR " + Str$(ERR)
            PRINT " Error at line " + Str$(_ERRORLINE)
            PRINT con$
            SLEEP
            cerre% = cerre% + 1
            aerr cerre%
        CASE 52, 64
            LOCATE lb%, 2
            PRINT "** Bad file name or num. file - ERROR " + Str$(ERR)
            PRINT " Error at line " + Str$(_ERRORLINE)
            PRINT con$
            SLEEP
            Perre% = Perre% + 1
            aerr perre%
        CASE 71
            LOCATE lb%, 2
            PRINT "** Disk not ready - ERROR " + Str$(ERR)
            PRINT " Error at line " + Str$(_ERRORLINE)
            PRINT con$
            SLEEP
            Derre% = Derre% + 1
            aerr derre%
        CASE 53, 76:    
            CLS
            LOCATE lb%, 2
            PRINT "** File or path not found - ERROR " + Str$(ERR)
            PRINT " The program does not find files cubdata.rbk "
            PRINT "  and/or transind.rbk which are necessary . "
            PRINT "  End of program! grind, and restart the program."
            PRINT " Error at line " + Str$(_ERRORLINE)
            PRINT "<press a key to end..>"
            SLEEP
            CLS
            SYSTEM 
        CASE 258
            LOCATE lb%, 2
            PRINT "** Bad handle - ERREUR " + Str$(ERR)
            PRINT " Error at line " + Str$(_ERRORLINE)
            INPUT " Continue any way <Y>  <N> "; thx$
            IF UCASE$(thx$) = "N" THEN SYSTEM
        CASE ELSE
            LOCATE lb%, 2
            PRINT "** ERROR " + Str$(ERR)
            '  assigne a 'label',  if  an error is possible
            ' at the location identified of the program
            IF ERL <> 0 THEN PRINT "Error at line label " + Str$(ERL)
            PRINT " Error at line " + Str$(_ERRORLINE)
    END SELECT
    efface 1, lb%, lb% + 6
    LOCATE lg%, pg%
    RESUME NEXT
    '  **** End of CUB641BE.bas (Main)****
 '********************************************************************
SUB Aerr (nerna%)
    IF nerna% > 10 THEN
        LOCATE lb% + 3, 2: PRINT "Too many errors"
        PRINT "Correct if possible and try again!"
        PRINT "<press a key to end..>"
        SLEEP
        SYSTEM
    END IF
END SUB
 '********************************************************************
SUB cfichier (pa%, mn$)
 ' create a file
 '********************************************************************
        pa% = pa% + 1
        PRINT "A file Rubik" + LTRIM$(Str$(pa%));".RBK will be created "
        Mn$ = "RUBIK" + LTRIM$(Str$(pa%)) + ".RBK"
END SUB
 '********************************************************************
SUB Affichier (pb%, md$())
 ' Printing the files
 '********************************************************************
    LOCATE 4, 3: PRINT "Availables files :"
    LOCATE 5, 3
    xu% = 0
    FOR i% = 1 to pb%
        xu% = xu% + 1
        IF LEN(md$(i%)) = 10 THEN
            COLOR p%(9)
            PRINT STR$(i%) + ". ";
            COLOR p%(7)
            PRINT md$(i%);" ";
        ELSE
            PRINT i%; md$(i%) ;
        END IF
        IF xu% = 5 THEN
            PRINT: LOCATE Csrlin, 3
            xu% = 0
        END IF
    NEXT i%    
END SUB
 '********************************************************************
SUB AffCadr (ap%)
 ' Printing a cadre on the screen
 '********************************************************************
    COLOR P%(7)
    bc$ = "* * * * R U B I K ' S   C U B E * * * *"
    boiteds 1, 1, cz% - 2, ap%
    LOCATE 2, ((cz% - 1) - INT(LEN(bc$))) / 2
    PRINT bc$
END SUB
 '********************************************************************
SUB AFFcol
 ' input: none
 ' output: Printing the COLORs of faces on the screen 
 '********************************************************************
    ' --- Help for COLORs of faces
    LOCATE 1, 2
    FOR t% = 1 TO nbfac%
        COLOR P%(t%)
        IF t% = 1 THEN
            PRINT nocou(co%(t%)).kol;" : "; co%(t%);
        ELSEIF t% = 3 OR t% = 5 THEN
            PRINT " ";nocou(co%(t%)).kol;" : "; co%(t%);
        ELSE
            LOCATE CSRLIN, pos(0) + 1
            PRINT nocou(co%(t%)).kol;" : "; co%(t%)
        END IF
    NEXT t%
    COLOR P%(1)
    PRINT
END SUB
 '********************************************************************
SUB Affect
 ' affecte the data on array of 20 steps
 '                    it's come  8 summits of 3 facets
 '                    and  12 ridges of 2 facets.
 ' input:             array commons     s%(),  C%()
 ' output:             array  s%() ,
 '                    array  C(i%, j%)
 '                    affect and control if it's a valid data
 '********************************************************************
    FOR i% = 1 TO nbfac%
        FOR j% = 1 TO nfacet%
        ' replace the value of C%(i, j) by the weight 2^(x-1)
            C%(i%, j%) = vo%(C%(i%, j%))
        NEXT j%
    NEXT i%
'    CLS
    ' ---- Detection of smalls cubes ----
    ' **Summits**
    ' for example:  s%(1) = C%(face1, cube 7) + C%(face2, cube 3) + C%(face3, cube 1)
    s%(1)  = C%(1, 7) + C%(2, 3) + C%(3, 1)    ' sum weight 2^x corner hight ahead left
    s%(2)  = C%(1, 1) + C%(2, 1) + C%(5, 3)    ' sum weight 2^x corner hight rear left
    s%(3)  = C%(1, 3) + C%(4, 3) + C%(5, 1)    ' sum weight 2^x corner hight rear right
    s%(4)  = C%(1, 9) + C%(3, 3) + C%(4, 1)    ' sum weight 2^x corner hight ahead right
    s%(5)  = C%(2, 9) + C%(3, 7) + C%(6, 1)    ' sum weight 2^x corner low ahead left
    s%(6)  = C%(2, 7) + C%(5, 9) + C%(6, 7)    ' sum weight 2^x corner low rear left
    s%(7)  = C%(4, 9) + C%(5, 7) + C%(6, 9)    ' sum weight 2^x corner low rear right
    s%(8)  = C%(3, 9) + C%(4, 7) + C%(6, 3)    ' sum weight 2^x corner low ahead right
    ' **ridges**
    s%(9)  = C%(1, 4) + C%(2, 2)            ' sum weight 2^x ridge hight left
    s%(10) = C%(1, 2) + C%(5, 2)            ' sum weight 2^x ridge hight rear
    s%(11) = C%(1, 6) + C%(4, 2)            ' sum weight 2^x ridge hight right
    s%(12) = C%(1, 8) + C%(3, 2)            ' sum weight 2^x ridge hight ahead
    s%(13) = C%(2, 6) + C%(3, 4)            ' sum weight 2^x ridge medium ahead left
    s%(14) = C%(2, 4) + C%(5, 6)            ' sum weight 2^x ridge medium rear left
    s%(15) = C%(4, 6) + C%(5, 4)            ' sum weight 2^x ridge medium rear right
    s%(16) = C%(3, 6) + C%(4, 4)            ' sum weight 2^x ridge medium ahead right
    s%(17) = C%(2, 8) + C%(6, 4)            ' sum weight 2^x ridge low left
    s%(18) = C%(5, 8) + C%(6, 8)            ' sum weight 2^x ridge low rear
    s%(19) = C%(4, 8) + C%(6, 6)            ' sum weight 2^x ridge low right
    s%(20) = C%(3, 8) + C%(6, 2)            ' sum weight 2^x ridge low ahead
    ' controle
    FOR i% = 1 TO 20
        IF (s%(i%) > 56) AND (i% <= 20) THEN
            PRINT " Impossibles data "
            EXIT FOR
        END IF
        FOR pt% = 1 to 20
            IF ss%(pt%) = s%(i%) THEN
                t%(i%) = pt%  ' position occupy  by the  cube
                EXIT FOR
            END IF
        NEXT pt%
        z%(t%(i%)) = i%    ' position who must have the  cube
    NEXT i%
    IF i% = 21 THEN
        tem% = 1
        initC 3
        Affcub L%, gm$, tem%
        ' If pm% <> 21, it's mistakes data!
    ELSEIF i% <> 21 THEN
        PRINT "The data are wrong! Fatal error - shutdown program"
        SLEEP
        SYSTEM
    END IF
END SUB
 '***********************************************************************
SUB Affcub (LI%, gm$, clm%) STATIC
 ' WARNING :  do not modify the order of  faces or be sure what you want to make !
 ' The order directly affects the display of facets compared to the tables!
 ' input: Li% = Nr facet    gm$ = command to execute     clm% = tem%
 ' output: draw the cube on the screen ; call to SUB TraceFace(...)
 '********************************************************************
    IF pmsa$ = "Y" AND ea% AND clm% = 1 THEN
        lign% = Csrlin: col% =  POS(0)
        LOCATE la%, 5: PRINT "< press a key to continue >"
        SLEEP
        LOCATE la%, 2: PRINT STRING$(40, " ")
        LOCATE lign%, col%
    ELSE
        delier# = .3: delay
        ea% = TRUE
    END IF
     ' ----- Graphic display routine -----
    ' face 1, 3, 4, 2, 5, 6
    TraceFace 1, 3, 4, 2, 5 , 6
    ' save the parametere line and colonne (texte) of the screen
    lign% = Csrlin: col% = POS(0) + 1
    IF scrn% = 1 THEN
        LOCATE 17, 23: PRINT "Face 1"
        LOCATE 31, 7: PRINT "Face 3" 
        LOCATE 26, 35: PRINT "Face 4"
        LOCATE 17, 60: PRINT "Face 2"
        LOCATE 31, 43: PRINT "Face 5"
        LOCATE 40, 54: PRINT "Face 6"
    ELSE
        LOCATE 15, 23: PRINT "Face 1"
        LOCATE 27, 5: PRINT "Face 3" 
        LOCATE 23, 34: PRINT "Face 4"
        LOCATE 15, 60: PRINT "Face 2"
        LOCATE 26, 42: PRINT "Face 5"
        LOCATE 34, 55: PRINT "Face 6"
    END IF
    ' get bak line and colonne
    IF col% > 80 then col% = 3
    LOCATE lign%, col%
    IF clm% = 1 THEN
        helpmov LI%, gm$
        lign% = Csrlin: col% = POS(0)
        IF pmsa$ = "Y" THEN
        '    LOCATE la%, 5: PRINT "< press a key to continue >"
            wl$ = UCASE$(INPUT$(1))
            effa52
            IF wl$ = "Q" THEN END
        ELSE
            ' It's used if "step by step"  = no
            wc$ = UCASE$(INKEY$)
            IF wc$ = "T" THEN
                SLEEP
            END IF
            Delier# = .110 + drl#:Delay
        END IF
        LOCATE lign%, col%
    END IF
END SUB
 '***********************************************************************
SUB Atrib (e1%, e2%, e3%, e4%, e5%, e6%, e7%, e8%, e9%, e10%, e11%)
 ' get the printing and commands
 ' K% to controle --> e1%, e2%     and         e3%, e4%
 ' e5% =  landmark for " K% - 1'
 ' e6% = landmark for "K% + 1"
 ' If  e11% = 0      THEN    e7% = q0%, e8% = q1% 
 ' If  e11% = 1      THEN    e7% = q0%, e8% = q1%, e9% = q2%, e10% = q3% 
 '***********************************************************************
     k1% = k% + 1: k2% = k% - 1
    IF (K% > e1%) AND (K% < e2%) AND (e6% = 0) THEN mn% = id1%(B%) + K%
    IF (K% > e1%) AND (K% < e2%) AND (e6% = 1) THEN mn% = id1%(B%) + K1%
        Rf1$ = Bf1$(mn%)
        Cm1$ = Bc1$(mn%) 
        IF (K% > e3%) AND (K% < e4%) AND (e5% = 0) THEN mm% = id2%(B%) + K%
        IF (K% > e3%) AND (K% < e4%) AND (e5% = 1) THEN mm% = id2%(B%) + K2%
        Rf2$ = Bf2$(mm%)
        Cm2$ = Bc2$(mm%)
    ' calculate the parameters to send
    IF e6% = 0 THEN jf% = (Calkoef%(bl%(), B%)) + K%
    IF e6% = 1 THEN jf% = (Calkoef%(bl%(), B%)) + K1%
    IF e11% = 0 THEN e7% = Aptst(jf%).tst1: e8% = Aptst(jf%).tst2
    IF e11% = 1 THEN e7% = Aptsk(jf%).tsk1: e8% = Aptsk(jf%).tsk2: e9% = Aptsk(jf%).tsk3: e10% = Aptsk(jf%).tsk4
END SUB
 '***********************************************************************
SUB Boiteds (ligx%, coly%, lng%, fin%) STATIC
 ' Draw a double line on  the screen
 '  input :           ligx% = Line begin
 '                    coly% = colonne begin
 '                    lng% = width of the frame
 '                    fin% =  end of the frame
 ' output :           Display cadre on the screen
 '**********************************************************************
    LOCATE ligx%, coly%: PRINT COIhdG$ + STRING$(lng%, HOriD$) + COIhdD$
    DO
        ligx% = ligx% + 1
        LOCATE ligx%, coly%: PRINT DCOte$ + STRING$(lng%, " ") + DCOte$
    LOOP UNTIL ligx% = fin%
    PRINT COIbdG$ + STRING$(lng%, HOriD$) + COIbdD$
END SUB
 '********************************************************************
SUB Efface (bde%, ew%, ey%)
 ' delete some lines of the screen
 '********************************************************************
    IF bde% = 0 THEN
        LOCATE 4, 3: PRINT STRING$(54, " ")
        LOCATE 6, 3: PRINT STRING$(74, " ")
        LOCATE 7, 3: PRINT STRING$(74, " ")
        LOCATE 8, 3: PRINT STRING$(54, " ")
        LOCATE 9, 3: PRINT STRING$(56, " ")
        LOCATE 12, 14: PRINT STRING$(60, " ")
    ELSE
        FOR ez% = ew% TO ey%
            LOCATE ez%, 1
            PRINT STRING$(cz%, " ")
        NEXT ez%
    END IF
END SUB
 '********************************************************************
SUB effa52
 ' delete line 52
 '********************************************************************
    LOCATE la%, 2: PRINT STRING$(70, " ")
END SUB
 '*********************************************************************
SUB CalcV (d%, e%, f%, g%, h%, al%)
 ' determines the value of:  B%,  K% , V%
 '  input:    B%, K%, V%, saut(dx%), saut(dx% + 1), saut(dx% + 2)
 ' Output:    B%, K%, V% updated
 '********************************************************************
    f% = cf%(g%, h%)            ' V%
    e% = z%(tf%(al%)) - (al% - 1)    ' K%
    d% = d% + 1                ' B%
END SUB
 '********************************************************************
FUNCTION Calkoef% (bl%(), B%)
 ' calculating the coefficients [jf%] called by Atrib for the routines 
 '        Test,        TestT1,    TestK1,    TestK2
 ' input :        bl%(), B%,
 ' output  :      kf1% ( = jf%) in the name of function Calkoef%
 '********************************************************************
    kf1% = 0
    ' cas B% = 1
    IF B% = 1 THEN kf1% = bl%(B%)
    ' cas B% between 2 and 4 or between 9 and 15
    IF (B% > 1 AND B% < 5) OR (B% >= 9 AND B% <= 15) THEN
        FOR nx% = 1 TO B%
            kf1% = kf1% + bl%(nx%)
            ' if B% between 9 and 15 shorten the loop
            IF (B% >= 9 AND B% <= 15) AND nx% = 4 THEN nx% = 8
        NEXT nx%
    ' cas B% between 5 and 8 or 16 to 18
    ELSEIF (B% >= 5 AND B% < 9) OR (B% > 15) THEN
        FOR nx% = 5 TO B%
            kf1% = kf1% + bl%(nx%)
            ' If B% between 16 and 18 shorten the loop
            IF (B% > 15) AND (nx% = 8) THEN nx% = 15
        NEXT nx%
    END IF
    Calkoef% = kf1%
END FUNCTION
 '********************************************************************
SUB Collect (cha1$, cha2$, cha3$, Mir$())
 ' obtain the catalog of directories and files.
 '********************************************************************
    cms$ = "command /c"
    SHELL _HIDE cmd$ + "dir " + cha1$ + " > " + cha2$    ' directories or files
    nfich% = FREEFILE
    OPEN cha2$ FOR INPUT AS nfich%
    IF LOF(nfich%) > 0 THEN
        jk% = 0
        DO UNTIL EOF(nfich%)
            LINE INPUT #nfich%, ir$
            ir$ = LCASE$(ir$)
            cha3$ = LCASE$(cha3$)
            IF INSTR(ir$, cha3$) THEN
                jk% = jk% + 1
                IF INSTR(ir$, ".rbk") THEN
                    xtfich% = TRUE
                    Mir$(jk%) = ir$
        '        ELSE
        '            xtdir% = TRUE
                END IF
            END IF
        LOOP
    END IF
    CLOSE #nfich%
    KILL cha2$
END SUB
 '********************************************************************
SUB Chks
 ' Checksum if the entries facets are correct 
 ' We need to find 9 white, 9 green...  and 9 yellow.
 '********************************************************************
    REDIM ctrl%(0 TO 6) 
    FOR op% = 1 TO nbfac%
        FOR om% = 1 TO nfacet%
            ' summing the facets of the same COLOR
            ctrl%(C%(op%,om%)) = ctrl%(C%(op%,om%)) + C%(op%, om%)
        NEXT om%
    NEXT op%
    op1% = la%: op2% = la% + 5
    FOR op% = op1% to op2%
        LOCATE op%, 2: PRINT STRING$(70, " ")
    NEXT op%
    dom% = op1%
    FOR op% = 1 TO nbfac%
        IF ctrl%(op%) <> co%(op%) * nfacet% THEN
            LOCATE dom%, 2 
            PRINT " you entered"; ctrl%(op%)/co%(op%); " facets "; nocou(op%).kol
            dom% = dom% + 1
        ELSE
            ctrl%(0) = ctrl%(0) + ctrl%(op%)
        END IF
    NEXT op%
    ' If checksum is correct, tem% = 1
    IF ctrl%(0) = 189 THEN
        tem% = 1
        ERASE ctrl% ' reclaim memory
    ELSE
        LOCATE CSRLIN, 2:PRINT " you have to restart entering the COLOR of the facets "
        tem% = 0
        LOCATE CSRLIN, 2
        PRINT con$
        SLEEP
        CLS
    END IF
END SUB
 '********************************************************************
SUB Delay
 ' Delay independent of the CPU speed. 
 ' Based on the timer ticks (18.2 times per second ) = 55ms 
 ' According to delier# in seconds. 
 ' If delier# = 0, no execution of the routine.
 '********************************************************************
    IF Delier# = 0 THEN EXIT SUB
    Debut# = TIMER
    WHILE TIMER - Debut# <= Delier#
    WEND
    Delier# = 0    ' reset delier# to 0
END SUB
 '********************************************************************
SUB dkolfac
 ' input:         Interface Men-machine.
 '                The target facet  is black.
 ' output:         Colors of the 54 facets in 6 groups of 9.
 '                 facet 5 of each face is assigned, an ex-officio.
 '                 At the start by default facets are gray.
 '********************************************************************
 ' Init color data of the facets
    DO
        IF tem% = 0 THEN
            FOR i% = 1 TO nbfac%
                FOR j% = 1 TO nfacet%
                    C%(i%, j%) = P%(8)
                    ' color of the facet 5
                    IF j% = 5 THEN C%(i%, j%) = i%
                NEXT j%
            NEXT i%
            Affcub j%, gm$, tem%
        END IF
        tem% = 0
        ' Input data for the 6 faces
        FOR i% = 1 TO nbfac%
            AFFcol
            LOCATE 5, 2: PRINT "    Face"; i%,
            PRINT
            ' and for the 9 facets
            FOR j% = 1 TO nfacet%
                DO
                    LOCATE 7, 32: PRINT STRING$(4, " ")
                    ' if facet 5, do nothing
                    IF j% = 5 THEN EXIT DO
                    LOCATE 7, 2: PRINT " COLOR of the facet   : "; j%; " "
                    C%(i%, j%) = 0
                    Affcub j%, gm$, tem%
                    DO UNTIL (C%(i%, j%) <= 6) AND (C%(i%, j%) > 0)
                        C%(i%, j%) = VAL(INKEY$)
                    LOOP
                    Affcub j%, gm$, tem%
                    EXIT DO
                LOOP
            NEXT j%
            LOCATE la%, 2: PRINT " Valid values (Y/N) :  ",
            lm$ = "" 
            lm$ = Req$(lm$, "Y", "N") 
            ' clear the message
            effa52
            ' If not correct entries
            IF lm$ = "N" THEN
                ' back facets gray
                FOR j% = 1 TO nfacet%
                    C%(i%, j%) = P%(8)
                    ' color of the facet 5
                    IF j% = 5 THEN C%(i%, j%) = i%
                NEXT j%
                ' refresh the screen
                Affcub j%, gm$, tem%
                '  update  i%
                i% = i% - 1
            END IF
        NEXT i%
        '  control if no duplicate entries
        '  if OK the witness "tem%" = 1
        Chks
        IF tem% = 1 THEN Affect: EXIT DO
    LOOP
END SUB
 '********************************************************************
SUB exmov (exc%, gm$)
 ' shared rotations routine execution  
 '********************************************************************
    IF exc% < 3 THEN ko% = 3
    IF exc% > 2 AND exc% < 5 THEN ko% = 5
    IF exc% > 4 AND exc% < 7 THEN ko% = 1
    IF exc% > 6 AND exc% < 9 THEN ko% = 6
    IF exc% > 8 AND exc% < 11 THEN ko% = 2
    IF exc% > 10 AND exc% < 13 THEN ko% = 4
    SELECT CASE exc%
        CASE 1, 3, 5, 7, 9, 11
            Sdlm Ko%, 3, 2, 1, 4, 7, 8, 9, 6
        CASE 2, 4, 6, 8, 10, 12
            Sdlm Ko%, 1, 2, 3, 6, 9, 8, 7, 4
    END SELECT
    Translat exc%, L%, gm$
END SUB
 '********************************************************************
SUB FaiLinit (vc%)
 ' Init the arrays C%() and tf%()
 ' vc% = config entry value based hi% and/or hf%
 '********************************************************************
    InitC vc%
    initF vc%
END SUB
 '********************************************************************
SUB helpmov (g%, gm$)
 ' helping hand and display rotation movements
 '
 '********************************************************************
    IF bd% = 0 OR g% > LEN(gm$) THEN EXIT SUB
    IF Col% > 70 THEN      ' for adjust the screen
        lign% = lign% + 1 :Col% = 2
        LOCATE lign%, Col%
    END IF 
    DO
        IF g% > LEN(gm$) THEN PRINT "            "; : EXIT DO
        ' consider a display for L% >= 10
        IF L% < 10 THEN Col% = Col% + 1: LOCATE lign%, Col%
        SELECT CASE bd%
            CASE 1, 3, 5, 7, 9, 11
                m% = &H2B ' signe +
            CASE 2, 4, 6, 8, 10, 12
                m% = &H2D ' signe -
        END SELECT
        IF bd% = 1 OR bd% = 2 THEN mc$ = "FRont  ": EXIT DO
        IF bd% = 3 OR bd% = 4 THEN mc$ = "BAck   ": EXIT DO
        IF bd% = 5 OR bd% = 6 THEN mc$ = "UP     ": EXIT DO
        IF bd% = 7 OR bd% = 8 THEN mc$ = "DOwn   ": EXIT DO
        IF bd% = 9 OR bd% = 10 THEN mc$ = "LEft   ": EXIT DO
        IF bd% = 11 OR bd% = 12 THEN mc$ = "RIght  ": EXIT DO
    LOOP
    PRINT L%; mc$ + CHR$(m%);
END SUB
 '********************************************************************
SUB InitC (y%)
 ' Init array      C%()     or
 '                 cf%() depending on the value of y%
 '********************************************************************
    FOR i% = 1 TO nbfac%
        FOR j% = 1 TO nfacet%
            IF y% = 1 THEN cf%(i%, j%) = C%(i%, j%)
            IF y% = 2 THEN C%(i%, j%) = i%
            IF y% = 3 THEN C%(i%, j%) = w%(C%(i%, j%))
        NEXT j%
    NEXT i%
END SUB
 '********************************************************************
SUB initF (rl%)
 ' Init array tf%()      or     t%() and z%()     or z%()
 ' according to value of rl%
 '********************************************************************
    FOR gk% = 1 TO 20
        IF rl% = 1 THEN tf%(gk%) = t%(gk%)
        IF rl% = 2 THEN t%(gk%) = gk%: z%(gk%) = gk%
        IF rl% = 3 THEN z%(t%(gk%)) = gk%
    NEXT gk%
END SUB
 '********************************************************************
FUNCTION invert$ (Miss AS STRING)
 ' Reversal of the message
    DIM ml$
    ml$ = LEFT$(Miss, 1) + MID$(Miss, 4, 1) + MID$(Miss, 3, 1) + MID$(Miss, 2, 1)
    ml$ = ml$ + MID$(Miss, 5, 1) + MID$(Miss, 8, 1) + MID$(Miss, 7, 1) + MID$(Miss, 6, 1)
    invert$ = ml$
END FUNCTION
 '********************************************************************
SUB invrc (chifr$())
 ' Reversal of tr$(1 to 4)
 ' 1 vers 1
    chifr$(1) = LEFT$(tr$(1), 1) + RIGHT$(tr$(1),1) + MID$(tr$(1),3,1) + MID$(tr$(1),2,1)
 ' 2 vers 4 chi$ = savegarde tr$(2)
    chi$ = chifr$(2)
    chifr$(2) = LEFT$(tr$(4), 1) + RIGHT$(tr$(4),1) + MID$(tr$(4),3,1) + MID$(tr$(4),2,1)
 ' 3 vers 3
    chifr$(3) = LEFT$(tr$(3), 1) + RIGHT$(tr$(3),1) + MID$(tr$(3),3,1) + MID$(tr$(3),2,1)
 ' 4 vers 2
    chifr$(4) = LEFT$(chi$, 1) + RIGHT$(chi$,1) + MID$(chi$,3,1) + MID$(chi$,2,1)
END SUB
 '********************************************************************
FUNCTION Mconfig% (cn$)
 ' user's Choice
 '********************************************************************
    SHARED hf%
    IF hf% = 0 THEN
        COLOR p%(7)
        boiteds 15, 1, cz% - 2, 37
        LOCATE 17, 2: PRINT "     You have 2 choices to make "
        COLOR p%(10): LOCATE 18, 2: PRINT " FINAL";
        COLOR p%(7): PRINT " configuration   and   ";
        COLOR p%(10): PRINT "INITIAL";
        COLOR p%(7): PRINT " Configuration. "
        LOCATE 19, 2: PRINT
        COLOR p%(10): LOCATE 20, 2: PRINT " FINAL";
        COLOR p%(7): PRINT " configuration:"
        LOCATE 21, 2: PRINT "  Choice '1': the cube will be in order at the end. "
        LOCATE 22, 2: PRINT "  Choice '2': You make the rotation of the faces to your own way "
        LOCATE 23, 2: PRINT
        COLOR p%(10): LOCATE 24, 2: PRINT " INITIAL";
        COLOR p%(7): PRINT " Configuration: "
        LOCATE 25, 2: PRINT "  If, for ";
        COLOR p%(10): PRINT "FINAL";
        COLOR p%(7): PRINT " Configuration, Your choice is '1', then "
        LOCATE 26, 2: PRINT "  It will be proposed to you:  3. COLORs of the facets to your choice. "
        LOCATE 27, 2: PRINT
        COLOR p%(10): LOCATE 28, 2: PRINT " FINAL = 1 and INITIAL = 2";
        COLOR p%(7): PRINT " ==> rotation of the faces and resolution. "
        COLOR p%(10): LOCATE 29, 2: PRINT " FINAL = 2 and INITIAL = 2";
        COLOR p%(7): PRINT " ==> rotation of the faces not of resolution. "
        COLOR p%(10): LOCATE 30, 2: PRINT " FINAL = 1 and INITIAL = 3";
        COLOR p%(7): PRINT " ==> to recover the data  or  to enter COLORs"
        LOCATE 31, 2: PRINT "    of the facets to one.  ==> resolution of the cube. "
        LOCATE 32, 2: PRINT
        COLOR p%(10): LOCATE 33, 2: PRINT " FINAL = 2 and INITIAL = 3";
        COLOR p%(7): PRINT " ==> to recover the data  or  to enter "
        LOCATE 34, 2: PRINT "   COLORs of the facets to one. "
        LOCATE 35, 2: PRINT "   in this case, ==> rotation of the faces but not resolution of the cube."
    END IF
    AffCadr 10
    LOCATE 4, 2: PRINT " Configuration ";
    COLOR P%(10): PRINT cn$;
    COLOR P%(1): PRINT " wished : " 
    LOCATE 6, 3: PRINT "    1. Cube in order"
    LOCATE 7, 3: PRINT "    2. Cubic obtained by rotation of the faces"
    IF hf% = 1 OR hf% = 2 THEN LOCATE 8,3: PRINT "    3. Colors of the facets to your choice"
    loq% = CSRLIN
    IF hf% = 1 THEN
        LOCATE la% + 2, 4: PRINT " Choice '3': You recover the data   or   you enter "
        LOCATE la% + 3, 4: PRINT "            COLORs of facets to one. "
    END IF
    COLOR p%(1): LOCATE loq%, 3: PRINT " Number of your choice : ";
    choi% = 0
    DO UNTIL (choi% > 0) AND (choi% <= 3)
        choi% = VAL(INKEY$)
    LOOP
    LOCATE CSRLIN, POS(0): PRINT LTRIM$(STR$(choi%))
    efface 1, la% + 2, la% + 3
    IF hf% = 1 THEN
        efface 1, la% + 2, la% + 3
    END IF
    mconfig% = choi%
    IF hf% <> 0 AND choi% <> 0 THEN efface 1, 15, 38
END FUNCTION
 '********************************************************************
SUB movself (zx%)
 ' Hand movements (simulation)
 '********************************************************************
    efface 1, 1, 14
    IF zx% = 1 THEN lign% = Csrlin: col% = POS(0)
    j% = 0
    DO
        efface 1, 1, 14
        COLOR P%(3)
        LOCATE 1, 22 : PRINT "   ***    Commands  list    ***"
        PRINT " "
        COLOR P%(7)
        LOCATE 3, 2: PRINT "  F - Front face ", "  B - Back face "
        LOCATE 4, 2: PRINT "  U - Up face  ", "  D - Down face"
        LOCATE 5, 2: PRINT "  L - Left face  ", "  R - Right face"
        LOCATE 6, 2: PRINT "  Q - Quit    If 'Q' is alone, if not, ignored"
        LOCATE 7, 2: PRINT " If letter is one = meaning of the watch, if '-' opposite "
        lq% = CSRLIN: pq% = POS(0)
        LOCATE la%, 2
        PRINT " You can get many commandes (without space) "
        PRINT " If cubic in order, test:   FFBBUUDDRRLL      it is remarkable! "
        PRINT "         remade in the same way, -->  Cubic in order ! "
        LOCATE lq%, pq%
        COLOR P%(1)
        initF 3
        Affcub L%, gm$, tem%
        LOCATE 8, 2:INPUT " Command : "; gm$
        gm$ = UCASE$(gm$)
        IF (LEN(gm$) = 1) AND (gm$ = "Q") THEN EXIT DO
        tem% = 1
        FOR L% = 1 TO LEN(gm$)
            r% = TRUE
            r$ = MID$(gm$, L%, 1)
            IF r$ = "-"  THEN j% = j% + 1: L% = L% + 1: r$ = MID$(gm$, L%, 1)
            IF r$ = "F" THEN    j% = j% + 1
            IF r$ = "B" THEN    j% = j% + 3
            IF r$ = "U" THEN    j% = j% + 5
            IF r$ = "D" THEN    j% = j% + 7
            IF r$ = "L" THEN    j% = j% + 9
            IF r$ = "R" THEN    j% = j% + 11
            IF INSTR("FBUDLR", r$) = 0 THEN
                L% = L% + 1
                r% = FALSE
            END IF
            IF r% THEN
                bd% = j%
                exmov j%, gm$
                j% = 0
            END IF
        NEXT L%
        initF 3
        Affcub L%, gm$, tem%
        Affect
    LOOP
    efface 1, la%, la% + 2
    Affect
END SUB
 '********************************************************************
SUB Posit (rr%, us%, tu%)    'STATIC
 '  Routine positioning on the screen
 ' values of     B%,        K%,       V%
 '********************************************************************
    LOCATE 8, 3: PRINT "B:"; rr%, "K:"; us%, "V:"; tu%, "COMMANDS"
    COLOR P%(9)
    LOCATE 9, 2: PRINT STRING$(38, CHR$(223)); STRING$(42, " ")
    COLOR P%(1)
    LOCATE Afli%, Afcol%
END SUB
 '********************************************************************
FUNCTION Req$ (t$, rp1$, rp2$)
    DO UNTIL t$ = rp1$ OR t$ = rp2$
        t$ = UCASE$(INKEY$)
    LOOP
    Req$ = t$
END FUNCTION
 '********************************************************************
SUB regles
    PCOPY 0, 1
    CLS
    Affcadr 2
    COLOR P%(7)
    LOCATE 6, 1
    PRINT TAB(6); "Few rules for resolve, and follow the movements"
    PRINT TAB(8); "    of RUBIK'S CUBE  in mode STEP by STEP "
    PRINT
    PRINT
    PRINT TAB(10); "1)    The CUBE don't move !!!"
    PRINT
    PRINT TAB(10); "2)    Uniquely, the faces move !!!"
    PRINT
    PRINT TAB(15); "         ORIENTATION "
    PRINT TAB(10); "   Face 1 (WHITE)  it's get UP. "
    PRINT TAB(10); "   Face 2 (GREEN)  it's get to left. "
    PRINT TAB(10); "   Face 3 (RED)    it's in front. "
    PRINT TAB(10); "   Face 4 (BLUE)   it's get to right. "
    PRINT TAB(10); "   Face 5 (ORANGE) it's get back. "
    PRINT TAB(10); "   Face 6 (YELLOW) it's get down "
    PRINT
    PRINT " After many movements, the cube must be the same at image on the screen. "
    PRINT "      If isn't , vous make a mistake sens (+ or -). "
    PRINT
    PRINT " Get your time, i dont know resolve the RUBIK's CUBE, but the "
    PRINT " program get it aesylly, the means that my cube is always in order. "
    PRINT TAB(15); " Good luke "
    PRINT
    PRINT con$
    SLEEP
    CLS
    PCOPY 1, 0
END SUB
 '********************************************************************
SUB Rotax (gm$)
 ' Executes the command placed in gm$: Rotate the faces
 '********************************************************************
    lign% = 9 :col% = 2
    COLOR P%(1)
    FOR L% = 1 TO LEN(gm$)
        bd% = ASC(MID$(gm$, L%, 1)) - 64
        exmov bd%, gm$
    NEXT L%
    IF L% > LEN(gm$) THEN
        Delier# = 1.5:Delay
        LOCATE Afli%, Afcol%: PRINT STRING$(cz% - afcol%, " ")
        FOR Gn% = 1 TO 5
            LOCATE Afli% + Gn%, 1: PRINT STRING$(cz% - 1, " ")
        NEXT Gn%
        LOCATE lign%, col%
    END IF
    stat% = stat% + LEN(gm$)
    initF 3
END SUB
 '********************************************************************
SUB LirEcrir (xfich%, C%(), nz%)
 ' Read from disk or write to disk
 ' depending on the value of nz%
 ' (nz%     = 1    read.)    (nz%    = 2    write.)
 '********************************************************************
    FOR i% = 1 TO nbfac%
        FOR j% = 1 TO nfacet%
            IF nz% = 1 THEN GET #xfich%, ,C%(i%, j%)
            IF nz% = 2 THEN PUT #xfich%, ,C%(i%, j%)
        NEXT j%
    NEXT i%
END SUB
 '********************************************************************
SUB Tablo (bor%, pfich%, Br$(), Ca$() )
 ' generators read from disk
 '********************************************************************
    FOR i% = 1 TO bor%
        IF i% <= bor%/2 THEN 
            INPUT #pfich%, Br$(i%)
        ELSE
            INPUT #Pfich%, Ca$(i% - bor%/2)
        END IF
    NEXT i%
END SUB
 '********************************************************************
SUB Tablau (bar%, kfich%, nd%(), na%())
 ' Index read from disk
 '********************************************************************
    FOR i% = 1 TO bar%
        IF i% <= bar%/2 THEN
            GET #kfich%, ,nd%(i%)
        ELSE
            GET #kfich%, ,na%(i% - bar%/2)
        END IF
    NEXT i%
END SUB
 '********************************************************************
SUB Tablax (ber%, lfich%, ncu%())
 ' Index read from disk
 '********************************************************************
    FOR i% = 1 TO ber%
        GET #lfich%, ,ncu%(i%)
    NEXT i%
END SUB
 '********************************************************************
SUB Tablat (bir%, ifich%, atu() AS bap, avu() AS sap, nt%)
 'read the index FORmat TYPE from disk 
 '********************************************************************
    FOR i% = 1 TO bir%
        IF nt% = 1 THEN
            GET #ifich%, , atu(i%).tst1
            GET #ifich%, , atu(i%).tst2
        ELSE
            GET #ifich%, , avu(i%).tsk1
            GET #ifich%, , avu(i%).tsk2
            GET #ifich%, , avu(i%).tsk3
            GET #ifich%, , avu(i%).tsk4
        END IF
    NEXT i%
END SUB 
 '********************************************************************
SUB Sdlm (kt%, s1%, s2%, s3%, s4%, s5%, s6%, s7%, s8%)
 ' Translation based on the faces of the cube
 ' Watch or reverse direction ( depending on the parameters s1% to s8% passed )
 ' input :
 ' kt% = identity of the face
 ' if s1% to s8% are 3, 2, 1, 4, 7, 8, 9, 6 then clockwise direction
 ' if s1% to.s8% are 1, 2, 3, 6, 9, 8, 7, 4 then the reverse of WATCH
 ' output:
 ' C%(kt%, sX%) translated according to the direction (sX% = of 1 to 8)
 '********************************************************************
    D1% = C%(kt%, s1%)
    D2% = C%(kt%, s2%)
    C%(kt%, s1%) = C%(kt%, s3%)
    C%(kt%, s2%) = C%(kt%, s4%)
    C%(kt%, s3%) = C%(kt%, s5%)
    C%(kt%, s4%) = C%(kt%, s6%)
    C%(kt%, s5%) = C%(kt%, s7%)
    C%(kt%, s6%) = C%(kt%, s8%)
    C%(kt%, s7%) = D1%
    C%(kt%, s8%) = D2%
END SUB
 '********************************************************************
SUB Test (c1%, c2%, av%, af$, cma$)
 ' display the contents of af$
 ' execution of the contents of cma$
 '********************************************************************
    IF (c1% > 0) AND (C%(c1%, c2%) = av%) THEN EXIT SUB
    COLOR P%(7)
    PRINT af$
    delier# = .5: delay
    rotax cma$
END SUB
 '********************************************************************
SUB TestT1 (d1%, d2%, vb%, f1a$, f2a$, mca1$, mca2$)
 ' display the contents of f1a$ OR f2a$
 ' execution of the contents of mca1$ OR mca2$
 '********************************************************************
    COLOR P%(7)
    IF C%(d1%, d2%) = vb% THEN
        PRINT f1a$
        delier# = .5: delay
        rotax mca1$
    ELSE
        PRINT f2a$
        delier# = .5: delay
        rotax mca2$
    END IF
END SUB
 '********************************************************************
SUB TestK1 (a1%, a2%, a3%, a4%, va1%, af1$, af2$, ac1$, ac2$)
 ' display the contents of    af1$ OR af2$
 ' execution of the contents of    ac1$ OR ac2$
 '********************************************************************
    IF C%(a1%, a2%) = va1% THEN EXIT SUB
    COLOR P%(7)
    IF C%(a3%, a4%) = va1% THEN
        PRINT af1$
        delier# = .5: delay
        rotax ac1$
    ELSE
        PRINT af2$
        delier# = .5: delay
        rotax ac2$
    END IF
END SUB
 '********************************************************************
SUB TestK2 (b1%, b2%, b3%, b4%, va%, fa1$, fa2$, fa3$, ca1$, ca2$, ca3$)
 ' display the contents of fa1$ OR fa2$ OR fa3$
 ' execution of the contents of ca1$ OR ca2$ OR ca3$
 '********************************************************************
    COLOR P%(7)
    IF C%(b1%, b2%) = va% THEN
        PRINT fa1$
        delier# = .5: delay
        rotax ca1$
    ELSEIF C%(b3%, b4%) = va% THEN
        PRINT fa2$
        delier# = .5: delay
        rotax ca2$
    ELSE
        PRINT fa3$
        delier# = .5: delay
        rotax ca3$
    END IF
END SUB
 '********************************************************************
SUB TraceFace (v1%, v2%, v3%, v4%, v5%, v6%)
 ' allocation of items Transmits v1% to v6% = face
 ' The parameters t1% to t13% are different depending on the face
 ' t14% and t15% are used only for the face 5
 '********************************************************************
    u0% = 0: u1% = CINT(30 * kfc): u2% = CINT(15 * kfc): u3% = CINT(Kfsn% * kfc)
    dt% = (u1% + spr%): du% = (u3% + spr%)
    dv% = (u2% + spr%)
    FOR v7% = 1 TO 6
        t4% = u0%: t5% = u2%: t6% = -u1%
        t7% = u0%: t8% = u3%: t9% = -u1%
        t10% = u1%: t11% = u0%: t13% = CINT(10 * kfc)
        IF v7% = 1 THEN
            t1% = v1%  ' V1% = face 1
            t2% = Kx1%: t3% = Ky1%
            t4% = -u3%: t9% = -u2%
            t12% = -CINT(15 * kfc)
        ELSEIF v7% = 2 THEN
            t1% = v2%  ' V2% =  face 3
            t2% = t2% - 2
            t3% = t3% + 1
            t5% = u1%: t8% = u0%
            t12% = -CINT(10 * kfc)
        ELSEIF v7% = 3 THEN
            t1% = v3%  ' V3% = face 4
            IF scrn% = 1 THEN
                t2% = t2% + ((2 * dt%) + du%) - spr% 
                t2% = t2% + 1
                t3% = t3% - (3 * dt%) - u3% - spr% - 1
                t3% = t3% - 1
            ELSE
                t2% = t2% + (2 * dt%) + du% - spr% + 1
                t3% = t3% - (3 * dt%) - u3% - spr% - 1
            END IF
            t5% = u1%: t6% = -u3%
            t7% = u2%: t8% = u0%
            t10% = u3%: t11% = -u2%
            t12% = -CINT(3 * kfc)
        ELSEIF v7% = 4 THEN
            t1% = v4%  ' V4% =  face 2
            ' position du curseur graphique en X (partie 2)
            ' position du curseur graphique en Y (partie 2)
            t2% = Kx2%: t3% = Ky2% - 1
            t5% = u1%: t8% = u0%
            t12% = -CINT(10 * kfc)
        ELSEIF v7% = 5 THEN
            t1% = v5%  ' V5% = face 5
            t2% = t2% - (2 * dt%) - spr%
            t3% = t3% - 2 * u1% - 1
            t4% = -u3%: t6% = u0%
            t7% = u1%: t9% = -u2%
            t10% = u0%: t11% = -u1%
            t12% = -CINT(4 * kfc) 
            t14% = t2%: t15% = t3%
        ELSEIF v7% = 6 THEN
            t1% = v6%  ' V6% =  face 6
            t2% = t2% + (3 * dt%) + (2 * spr%)
            t3% = t3% - (2 * dv%) - spr%
            t4% = -u3%: t6% = u1%
            t9% = -u2%: t10% = -u1%
            t12% = CINT(15 * kfc)
        END IF
        FOR i% = 0 TO 2
            ' I% from 0 instead of 1 for the calculation
            ' used in PAINT.... P% ( C% (t1% (3 * i% +j% )))
            FOR j% = 1 TO 3
                ' fixed coordinate x1, y1 Relative plot x1  dx, y1  dy
                LINE (t2%, t3%)-STEP(t4%, t5%), 7
                ' Relative plot x1 = x1  dx, y1 = y1   dy
                LINE -STEP(t6%, t7%), 7
                '  Relative plot x1 = x1  dx, y1 = y1  dy
                LINE -STEP(t8%, t9%), 7
                '  Relative plot x1 = x1  dx, y1 = y1  dy
                LINE -STEP(t10%, t11%), 7
                ' facet color, the pointer must be inside the border closed!
                PAINT STEP(t12%, t13%), P%(C%(t1%, (3 * i% + j%))), 7
                ' update(s) pointer(s) graphic(s) for future internal layout
                ' of the corresponding face.
                ' EX: In the face (t1%) the procedure trace facets 1, 2 and 3
                IF t1% > 0 AND t1% < 4 THEN
                    t2% = t2% + dt%
                ELSEIF t1% = 4 THEN 
                    t2% = t2% + du% 
                    IF scrn% = 1 AND t1% = 4 AND t2% => 242 THEN t2% = t2% - 1 'AND t2% => 242
                    IF scrn% = 2 AND t1% = 4 AND t2% => 270 THEN t2% = t2% -2
                    t3% = t3% - dv% + 1
                ELSEIF t1% = 5 THEN 
                    t2% = t2% + du% 
                    t3% = t3% - dv% - 1
                ELSE
                    t2% = t2% - du%
                    t3% = t3% + dv%
                END IF
            NEXT j%
            ' update the graphics pointers x and y for the future path 
            ' The procedure prepares the layout of the facets 4, 5 and 6 and 
            ' The layout of the facets 7, 8 and 9   t1% = No Face 
            IF t1% = 1 THEN
                t2% = t2% - (3 * dt%) - u3% - 1
                t3% = t3% + dv%
            ELSEIF t1% = 2 OR t1% = 3 THEN
                t2% = t2% - (3 * dt%)
                t3% = t3% + dt% + 1
            ELSEIF t1% = 4 THEN
                    t2% = t2% - (3 * du%)
                    t3% = t3% + (3 * (u1% - spr%))
                IF scrn% = 1 THEN
                    t2% = t2% + spr%
                    t3% = t3% - spr%
                ELSE
                    t2% = t2% + spr% + 1
                    t3% = t3% + 1
                END IF
            ELSEIF t1% = 5 THEN
                t2% = t14%
                t3% = t15% + dt% - 1
                t14% = t2%
                t15% = t3%
            ELSE
                t2% = t2% + du% + spr% 
                t3% = t3% - (3 * du%)
            END IF
        NEXT i%
    NEXT v7%
END SUB
 '********************************************************************
SUB TRI (am$())
 '  put the files in order.
 '------------------------------------------------------------------------------
    DIM tbx$(16)
    SHARED mind%
    FOR i% = 1 to mind%
        IF INSTR(am$(i%), ".") = 7 THEN
            xi% = VAL(MID$(am$(i%), 6, 1))
            tbx$(xi%) = am$(i%)
        ELSE
            xi% = VAL(MID$(am$(i%), 6, 2))
            tbx$(xi%) = am$(i%)
        END IF
    NEXT I%
    FOR I% = 1 TO MIND%
        am$(i%) = tbx$(I%)
    NEXT i%
    ERASE tbx$
END SUB
 '********************************************************************
SUB Translat (mx%, lz%, ll$)    'STATIC
 ' Performs the translation of the elementary cubes after the rotation of the faces
 ' Using Variables bt%, bu%, bv%, bw% of value 1, 2, 3 and 4
 '********************************************************************
    DIM R.Ms AS STRING * 8
    SELECT CASE mx%
        CASE 1, 2
'   Rotation front face SENSE WATCH
            tr$(1) = "1987"
            tr$(2) = "2369"
            tr$(3) = "6123"
            tr$(4) = "4741"
            R.Ms = "AEHDPLMT"
'   Rotate front face opposite direction of the WATCH
            IF mx% = 2 THEN invrc tr$(): R.Ms = Invert$(R.Ms) ' = '"ADHEPTML"
        CASE 3, 4
'   Rear View Rotating clockwise direction
            tr$(1) = "1123"
            tr$(2) = "4369"
            tr$(3) = "6987"
            tr$(4) = "2741"
            R.Ms = "BCGFJORN"
'   Rear View Rotating opposite direction of the WATCH
            IF mx% = 4 THEN invrc tr$(): R.Ms = Invert$(R.Ms) ' = "BFGCJNRO"
        CASE 5, 6
'   Rotation Face high sense of the WATCH
            tr$(1) = "3123"
            tr$(2) = "4123"
            tr$(3) = "5123"
            tr$(4) = "2123"
            R.Ms = "ADCBILKJ"
'   Rotation Face high opposite direction of the WATCH
            IF mx% = 6 THEN invrc tr$(): R.Ms = Invert$(R.Ms) ' = "ABCDIJKL"
        CASE 7, 8
'   Rotate bottom face clockwise direction
            tr$(1) = "3987"
            tr$(2) = "2987"
            tr$(3) = "5987"
            tr$(4) = "4987"
            R.Ms = "EFGHQRST"
'   Rotate bottom face wall opposite direction of the WATCH
            IF mx% = 8 THEN invrc tr$(): R.Ms = Invert$(R.Ms) ' = "EHGFQTSR"
        CASE 9, 10
'   Rotate left face clockwise direction
            tr$(1) = "1741"
            tr$(2) = "5369"
            tr$(3) = "6741"
            tr$(4) = "3741"
            R.Ms = "ABFEINQM"
'   Rotate left face opposite direction of the WATCH
            IF mx% = 10 THEN invrc tr$(): R.Ms = Invert$(R.Ms) ' = "AEFBIMQN"
        CASE 11, 12
'   Rotate right face clockwise direction
            tr$(1) = "1369"
            tr$(2) = "3369"
            tr$(3) = "6369"
            tr$(4) = "5741"
            R.Ms = "DHGCKPSO"
'   Rotate right face opposite direction of the WATCH
            IF mx% = 12 THEN invrc tr$(): R.Ms = Invert$(R.Ms) ' = "DCGHKOSP"
    END SELECT
    REDIM ma%(4), kf%(4, 3), E%(8)
    FOR ix% = 1 TO 4
        ma%(ix%)    = VAL(LEFT$(tr$(ix%), 1))
        kf%(ix%, bt%)    = VAL(MID$(tr$(ix%), 2, 1))
        kf%(ix%, bu%)    = VAL(MID$(tr$(ix%), 3, 1))
        kf%(ix%, bv%)    = VAL(RIGHT$(tr$(ix%), 1))
    NEXT ix%
    D1% = C%(ma%(bt%), kf%(bt%, bt%))
    D2% = C%(ma%(bt%), kf%(bt%, bu%))
    D3% = C%(ma%(bt%), kf%(bt%, bv%))
    C%(ma%(bt%), kf%(bt%, bt%))    = C%(ma%(bu%), kf%(bu%, bt%))
    C%(ma%(bt%), kf%(bt%, bu%))    = C%(ma%(bu%), kf%(bu%, bu%))
    C%(ma%(bt%), kf%(bt%, bv%))    = C%(ma%(bu%), kf%(bu%, bv%))
    C%(ma%(bu%), kf%(bu%, bt%))    = C%(ma%(bv%), kf%(bv%, bt%))
    C%(ma%(bu%), kf%(bu%, bu%))    = C%(ma%(bv%), kf%(bv%, bu%))
    C%(ma%(bu%), kf%(bu%, bv%))    = C%(ma%(bv%), kf%(bv%, bv%))
    C%(ma%(bv%), kf%(bv%, bt%))    = C%(ma%(bw%), kf%(bw%, bt%))
    C%(ma%(bv%), kf%(bv%, bu%))    = C%(ma%(bw%), kf%(bw%, bu%))
    C%(ma%(bv%), kf%(bv%, bv%))    = C%(ma%(bw%), kf%(bw%, bv%))
    C%(ma%(bw%), kf%(bw%, bt%))    = D1%
    C%(ma%(bw%), kf%(bw%, bu%))    = D2%
    C%(ma%(bw%), kf%(bw%, bv%))    = D3%
    FOR y% = 1 TO LEN(R.Ms)
        E%(y%) = ASC(MID$(R.Ms, y%, 1)) - 64
    NEXT y%
    FOR y% = 1 TO UBOUND(E%)
        IF y% = 1 THEN It% = t%(E%(y%))
        IF y% < 4 THEN t%(E%(y%)) = t%(E%(y% + 1))
        IF y% = 4 THEN t%(E%(y%)) = It%
        IF y% = 5 THEN It% = t%(E%(y%))
        IF (y% >= 5) AND (y% < 8) THEN t%(E%(y%)) = t%(E%(y% + 1))
        IF y% = 8 THEN t%(E%(y%)) = It%
    NEXT y%
    Affcub lz%, ll$, tem%
END SUB
'******************************************************************************
' End of file "CUB641BE.bas"
